#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

#include "badpenguin-ansi.h"
#include "badpenguin-errors.h"

#define SH(p) ((ush)(uch)((p)[0]) | ((ush)(uch)((p)[1]) << 8))
#define LG(p) ((ulg)(SH(p)) | ((ulg)(SH((p)+2)) << 16))

typedef unsigned char  uch;
typedef unsigned short ush;
typedef unsigned long  ulg;

// The size of the uncompressed stream is stored into the
// last 4 bytes of the gzip archive (see the RFC)
long untar_realsize(char *filename) {
  int fd;
  long rb, isize;
  unsigned char buf[4];

  fd = open( filename, 0, O_RDONLY  );
  if (fd<0) {
    printWARNING("untar: cannot open %s for gzlist\n",filename);
    normal_color();
    return 0;
  }
  rb = (long)lseek(fd, (off_t)(-4), SEEK_END);
  isize = 0;
  if ( rb != -1L) {
//    rb += 8L;
    if (read( fd, (char*)buf, sizeof(buf)) != sizeof(buf)) {
      printWARNING("untar: read error on %s gzlist\n",filename);
      normal_color();
      close(fd);
      return 0;
    }
//    crc       = LG(buf);
    isize     = LG(buf);
  }
  close(fd);
  //printf("crc..: %li \n", crc );
  //printf("isize: %li \n", isize );
  return isize;
}
